###############################################################################
###############################################################################
##
##  Copyright (C) 2004-2005 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################
%define buildup 1
%define buildsmp 1
%define buildhugemem 1
%define buildlargesmp 1
%define buildxen 1
%define kernel_version 2.6.9-89.0.7.EL
%define subversion 43
 
%ifnarch i686 x86_64
%define buildsmp 0
%define buildxen 0
%endif

%ifnarch i686
%define buildhugemem 0
%endif

%ifnarch ia64 x86_64 ppc64
%define buildlargesmp 0
%endif

Name: cmirror-kernel
Version: 2.6.9
Release: %{subversion}.12%{?dist}.2
License: GPL
Group: System Environment/Kernel
Summary: cmirror-kernel - The Cluster Mirror kernel modules
BuildRequires: kernel-devel = %{kernel_version}
BuildRequires: cman-kernel

%if %{buildsmp}
BuildRequires: kernel-smp-devel = %{kernel_version}
BuildRequires: cman-kernel-smp
%endif

%if %{buildhugemem}
BuildRequires: kernel-hugemem-devel = %{kernel_version}
BuildRequires: cman-kernel-hugemem
%endif

%if %{buildlargesmp}
BuildRequires: kernel-largesmp-devel = %{kernel_version}
BuildRequires: cman-kernel-largesmp
%endif

%if %{buildxen}
BuildRequires: kernel-xenU-devel = %{kernel_version}
BuildRequires: cman-kernel-xenU
%endif

BuildRequires: cman-kernheaders
Conflicts: GFS <= 6.0
Conflicts: GFS-modules GFS-modules-smp GFS-modules-hugemem
Requires: kernel = %{kernel_version}
Requires: /lib/modules/%{kernel_version}
Provides: kernel-modules
Provides: cmirror-kernel-modules = %{version}-%{release}
ExclusiveArch: i686 ia64 x86_64 ppc64
Source0: %{name}-%{version}-%{subversion}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
cmirror-kernel - The Cluster Mirror kernel modules

#%package -n cmirror-kernheaders
#Group: Development/System
#Summary: cmirror kernel header files

#%description -n cmirror-kernheaders
#The cmirror kernel headers are used by various cluster packages.

%if %{buildsmp}
%package -n cmirror-kernel-smp
Group: System Environment/Kernel
Summary: cmirror-kernel-smp - The Cluster Mirror kernel smp modules
Requires: kernel-smp = %{kernel_version}
Requires: /lib/modules/%{kernel_version}smp
Provides: kernel-modules
Provides: cmirror-kernel-modules = %{version}-%{release}
%description -n cmirror-kernel-smp
cmirror-kernel-smp - The Cluster Mirror kernel smp modules
%endif

%if %{buildhugemem}
%package -n cmirror-kernel-hugemem
Group: System Environment/Kernel
Summary: cmirror-kernel - The Cluster Mirror kernel hugemem modules
Requires: kernel-hugemem = %{kernel_version}
Requires: /lib/modules/%{kernel_version}hugemem
Provides: kernel-modules
Provides: cmirror-kernel-modules = %{version}-%{release}

%description -n cmirror-kernel-hugemem
cmirror-kernel-hugemem - The Cluster Mirror kernel hugemem modules
%endif

%if %{buildlargesmp}
%package -n cmirror-kernel-largesmp
Group: System Environment/Kernel
Summary: cmirror-kernel - The Cluster Mirror kernel largesmp modules
Requires: kernel-largesmp = %{kernel_version}
Requires: /lib/modules/%{kernel_version}largesmp
Provides: kernel-modules
Provides: cmirror-kernel-modules = %{version}-%{release}

%description -n cmirror-kernel-largesmp
cmirror-kernel-largesmp - The Cluster Mirror kernel largesmp modules
%endif

%if %{buildxen}
%package -n cmirror-kernel-xenU
Group: System Environment/Kernel
Summary: cmirror-kernel - The Cluster Mirror kernel xenU modules
Requires: kernel-xenU = %{kernel_version}
Requires: /lib/modules/%{kernel_version}xenU
Provides: kernel-modules
Provides: cmirror-kernel-modules = %{version}-%{release}

%description -n cmirror-kernel-xenU
cmirror-kernel-xenU - The Cluster Mirror kernel xenU modules
%endif

################################################################################
##  THE PREP SECTION
################################################################################
%prep
%setup -q -n %{name}-%{version}-%{subversion}
# Put the version information into the necessary files

################################################################################
##  THE BUILD SECTION
################################################################################
%build

BUILD_DIR=`pwd`
ROOT_DIR_FILES=`ls`
mkdir up
mv  $ROOT_DIR_FILES up
cp -r up smp
cp -r up hugemem
cp -r up largesmp
cp -r up xenU

Build_cmirror(){
	cpu_type=$1
	flavor=$2
	kernel_src=/lib/modules/%{kernel_version}$flavor/build
	# Kernel tree setup
	if [ -d $kernel_src/. ]; then
		echo $kernel_src
	else
		echo "Kernel %{kernel_version} not found."
		echo $kernel_src
		ls /lib/modules/*
		exit 1
	fi

	./configure --kernel_src=$kernel_src --incdir=%{_includedir}
        make symverfile=/lib/modules/%{kernel_version}$flavor/kernel/cluster/cman.symvers
        ls -l /lib/modules/%{kernel_version}$flavor/kernel/cluster/cman.symvers
#	$kernel_src/scripts/mod/modpost -m -i $kernel_src/Module.symvers src/cmirror.o -o cmirror.symvers
#	touch cmirror.symvers
}



%if %{buildup}
cd up
Build_cmirror %{_target_cpu}
cd ..
%endif

%if %{buildsmp}
cd smp
Build_cmirror %{_target_cpu} smp
cd ..
%endif

%if %{buildhugemem}
cd hugemem
Build_cmirror %{_target_cpu} hugemem
cd ..
%endif

%if %{buildlargesmp}
cd largesmp
Build_cmirror %{_target_cpu} largesmp
cd ..
%endif

%if %{buildxen}
cd xenU
Build_cmirror %{_target_cpu} xenU
cd ..
%endif

################################################################################
##  THE INSTALL SECTION
################################################################################
%install
rm -rf $RPM_BUILD_ROOT

%if %{buildup}
cd up
make install DESTDIR=$RPM_BUILD_ROOT symverfile=/lib/modules/%{kernel_version}/kernel/cluster/cman.symvers
#install cmirror.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}/kernel/cluster/
cd ..
%endif

%if %{buildsmp}
cd smp
make install DESTDIR=$RPM_BUILD_ROOT symverfile=/lib/modules/%{kernel_version}smp/kernel/cluster/cman.symvers
#install cmirror.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}smp/kernel/cluster/
cd ..
%endif

%if %{buildhugemem}
cd hugemem
make install DESTDIR=$RPM_BUILD_ROOT symverfile=/lib/modules/%{kernel_version}hugemem/kernel/cluster/cman.symvers
#install cmirror.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}hugemem/kernel/cluster/
cd ..
%endif

%if %{buildlargesmp}
cd largesmp
make install DESTDIR=$RPM_BUILD_ROOT symverfile=/lib/modules/%{kernel_version}largesmp/kernel/cluster/cman.symvers
#install cmirror.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}largesmp/kernel/cluster/
cd ..
%endif

%if %{buildxen}
cd xenU
make install DESTDIR=$RPM_BUILD_ROOT symverfile=/lib/modules/%{kernel_version}xenU/kernel/cluster/cman.symvers
#install cmirror.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}xenU/kernel/cluster/
cd ..
%endif

################################################################################
##  THE CLEAN SECTION
################################################################################
%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/depmod -e %{kernel_version}

%if %{buildsmp}
%post smp
/sbin/depmod -e %{kernel_version}smp
%endif

%if %{buildhugemem}
%post hugemem
/sbin/depmod -e %{kernel_version}hugemem
%endif

%if %{buildlargesmp}
%post largesmp
/sbin/depmod -e %{kernel_version}largesmp
%endif

%if %{buildxen}
%post xenU
/sbin/depmod -e %{kernel_version}xenU
%endif

%files
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}/kernel/cluster
/lib/modules/%{kernel_version}/kernel/cluster/*

%if %{buildsmp}
%files -n cmirror-kernel-smp
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}smp/kernel/cluster
/lib/modules/%{kernel_version}smp/kernel/cluster/*
%endif

%if %{buildhugemem}
%files -n cmirror-kernel-hugemem
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}hugemem/kernel/cluster
/lib/modules/%{kernel_version}hugemem/kernel/cluster/*
%endif %{buildhugemem}

%if %{buildlargesmp}
%files -n cmirror-kernel-largesmp
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}largesmp/kernel/cluster
/lib/modules/%{kernel_version}largesmp/kernel/cluster/*
%endif %{buildlargesmp}

%if %{buildxen}
%files -n cmirror-kernel-xenU
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}xenU/kernel/cluster
/lib/modules/%{kernel_version}xenU/kernel/cluster/*
%endif %{buildxenU}

#%files -n cmirror-kernheaders
#%defattr(-,root,root,-)
#%dir %{_includedir}/cluster
#%{_includedir}/cluster/*

%changelog
* Tue Aug 11 2009 Chris Feist <cfeist@redhat.com>
- Build for kernel-2.6.9-89.0.7.EL
- Resolves: rhbz#516929

* Wed Jul 08 2009 Chris Feist <cfeist@redhat.com>
- Build for kernel-2.6.9-89.0.3.EL
- Resolves: rhbz#510075

* Tue May 05 2009 Chris Feist <cfeist@redhat.com>
- Built for kernel-2.6.9-89.EL

* Tue Jul 01 2008 Chris Feist <cfeist@redhat.com>
- If a write-recovery conflict is detected, halt recovery rather than
  calling BUG().

* Fri Jun 20 2008 Chris Feist <cfeist@redhat.com>
- in_sync variable is now reset when resuming.

* Tue Apr 08 2008 Chris Feist <cfeist@redhat.com>
- Mirror log can be created without the 'block_on_error' flag
- An infinite election loop has been fixed
- Resolves: rhbz#193067 rhbz#217895

* Thu Mar 20 2008 Chris Feist <cfeist@redhat.com>
- Prevent server from issuing IO requests on devices that are suspended by
  changing a blocking IO to an async IO.
- Resolves: rhbz#217895

* Thu Nov 08 2007 Chris Feist <cfeist@redhat.com>
- Built for 2.6.9-67.EL kernel

* Wed Oct 03 2007 Chris Feist <cfeist@redhat.com>
- A hang was fixed when converting from one mirror type to another.
- Resolves: rhbz#316031

* Fri Sep 28 2007 Chris Feist <cfeist@redhat.com>
- cmirror write path no longer appears deadlocked after recovery
- Touch up on keeping cluster mirrors in sync when nominal and resync I/O
  overlap.
- Resolves: rhbz#290821, rhbz#291521

* Mon Sep 24 2007 Chris Feist <cfeist@redhat.com>
- Cluster mirrors no longer become out of sync if nominal and resync I/O
  overlap.
- Resolves: rhbz#291521

* Thu Sep 13 2007 Chris Feist <cfeist@redhat.com>
- Prevent deadlock during flush/recovery.
- Resolves: rhbz#257881

* Wed Aug 29 2007 Chris Feist <cfeist@redhat.com>
- When two logs are loaded that represent the same entity the second log
  now starts suspended.
- Resolves: rhbz#239856

* Mon Aug 20 2007 Chris Feist <cfeist@redhat.com>
- Disable xen until kernel is fixed

* Fri Aug 17 2007 Chris Feist <cfeist@redhat.com>
- Remote recovery conflict fixed.
- Resolves: rhbz#238629

* Fri Jan 12 2007 Chris Feist <cfeist@redhat.com>
- Added support for xenU kernels.

* Wed Nov 29 2006 Chris Feist <cfeist@redhat.com>
- New upstream sources.

* Thu May 18 2006 Chris Feist <cfeist@redhat.com>
- Added support for largesmp kernels.

* Wed Jul 27 2005 Chris Feist <cfeist@redhat.com>
- Initial package creation.
